diff --git a/oflog/libsrc/threads.cc b/oflog/libsrc/threads.cc
index 2c812b3..9109753 100644
--- a/oflog/libsrc/threads.cc
+++ b/oflog/libsrc/threads.cc
@@ -18,142 +18,187 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-//#include <cassert>
-#define INCLUDE_CASSERT
-//#include <exception>
-//#include <stdexcept>
-//#include <errno.h>
-#define INCLUDE_CERRNO
-#define INCLUDE_CSTDLIB
+#include "dcmtk/oflog/config.h"
 
-#include "dcmtk/ofstd/ofstdinc.h"
+#include <exception>
+#include <ostream>
+#include <cerrno>
 
-#include "dcmtk/oflog/config.h"
+#ifdef DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H
+#include <sys/types.h>
+#endif
 
-#ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
+#ifdef DCMTK_LOG4CPLUS_HAVE_SYS_SYSCALL_H
+#include <sys/syscall.h>
+#endif
+
+#ifdef DCMTK_LOG4CPLUS_HAVE_ERRNO_H
+#include <errno.h>
+#endif
+
+#ifdef DCMTK_LOG4CPLUS_HAVE_UNISTD_H
+#include <unistd.h>
+#endif
 
 #if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
+#  include <pthread.h>
 #  include <sched.h>
 #  include <signal.h>
-#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS) && ! defined (_WIN32_WCE)
-#  include <process.h>
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+#  include <process.h> 
 #endif
-
-#include "dcmtk/oflog/helpers/threads.h"
+#include "dcmtk/oflog/config/windowsh.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include "dcmtk/oflog/tstring.h"
+#include "dcmtk/oflog/internal/cygwin32.h"
 #include "dcmtk/oflog/streams.h"
+
+#ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
+
+#include "dcmtk/oflog/thread/threads.h"
+#include "dcmtk/oflog/thread/impl/thredimp.h"
+#include "dcmtk/oflog/thread/impl/tls.h"
 #include "dcmtk/oflog/ndc.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/helpers/strhelp.h"
 #include "dcmtk/oflog/helpers/timehelp.h"
-#include "dcmtk/oflog/helpers/syncprims.h"
+#include "dcmtk/oflog/internal/internal.h"
 
+#endif // DCMTK_LOG4CPLUS_SINGLE_THREADED
 
-namespace dcmtk { namespace log4cplus { namespace thread {
 
+namespace dcmtk {
+namespace log4cplus { namespace thread {
 
-struct ThreadStart
+DCMTK_LOG4CPLUS_EXPORT
+void
+blockAllSignals()
 {
-#  ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
-static void* threadStartFuncWorker(void *);
-#  elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
-static unsigned threadStartFuncWorker(void *);
-#  endif
-};
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+    // Block all signals.
+    sigset_t signal_set;
+    sigfillset (&signal_set);
+    pthread_sigmask (SIG_BLOCK, &signal_set, 0);
+#endif    
+}
 
 
-} } } // namespace dcmtk { namespace log4cplus { namespace thread {
+DCMTK_LOG4CPLUS_EXPORT
+void
+yield()
+{
+#if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
+    sched_yield();
+#elif defined(_WIN32)
+#if !defined(_MSC_VER) || _MSC_VER > 1200 /* MSC 6 doesn't know this */
+    if (! SwitchToThread ())
+#endif
+        Sleep (0);
+#endif
+}
 
 
-namespace
+DCMTK_LOG4CPLUS_EXPORT
+log4cplus::tstring const &
+getCurrentThreadName()
 {
+#if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+    log4cplus::tstring & name = log4cplus::internal::get_thread_name_str ();
+    if (name.empty ())
+    {
+        log4cplus::tostringstream tmp;
+        tmp << impl::getCurrentThreadId ();
+        // tmp.str ().swap (name);
+        name = OFString(tmp.str().c_str(), tmp.str().length());
+    }
+#else
+    static log4cplus::tstring const name (DCMTK_LOG4CPLUS_TEXT ("single"));
+#endif
 
-#  ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
-extern "C" void * threadStartFunc(void * param)
-#  elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
-static unsigned WINAPI threadStartFunc(void * param)
-#  endif
-{
-    return dcmtk::log4cplus::thread::ThreadStart::threadStartFuncWorker (param);
+    return name;
 }
 
-} // namespace
 
+namespace
+{
 
-namespace dcmtk { namespace log4cplus { namespace thread {
 
+static
+bool
+get_current_thread_name_alt (log4cplus::tostream * s)
+{
+    log4cplus::tostream & os = *s;
 
-///////////////////////////////////////////////////////////////////////////////
-// public methods
-///////////////////////////////////////////////////////////////////////////////
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS) && defined (__linux__) \
+    && defined (DCMTK_LOG4CPLUS_HAVE_GETTID)
+    pid_t tid = syscall (SYS_gettid);
+    os << tid;
+
+#elif defined (__CYGWIN__)
+    unsigned long tid = cygwin::get_current_win32_thread_id ();
+    os << tid;
+    
+#else
+    os << getCurrentThreadName ();
 
-DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE
-createNewMutex()
-{
-#if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
-    ::pthread_mutex_t* m = new ::pthread_mutex_t;
-    ::pthread_mutex_init(m, NULL);
-#elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
-    ::CRITICAL_SECTION* m = new ::CRITICAL_SECTION;
-    ::InitializeCriticalSection(m);
 #endif
-    return m;
+
+    return true;
 }
 
 
-void
-deleteMutex(DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE m)
+} // namespace
+
+
+DCMTK_LOG4CPLUS_EXPORT
+log4cplus::tstring const &
+getCurrentThreadName2()
 {
-#if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
-    ::pthread_mutex_destroy(m);
-#elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
-    ::DeleteCriticalSection(m);
-#endif
-    delete m;
-}
+#if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+    log4cplus::tstring & name = log4cplus::internal::get_thread_name2_str ();
+    if (name.empty ())
+    {
+        log4cplus::tostringstream tmp;
+        get_current_thread_name_alt (&tmp);
+        name = OFString(tmp.str().c_str(), tmp.str().length());
+    }
 
+#else
+    static log4cplus::tstring const name (getCurrentThreadName ());
 
+#endif
 
-#if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
-pthread_key_t*
-createPthreadKey(void (*cleanupfunc)(void *))
-{
-    ::pthread_key_t* key = new ::pthread_key_t;
-    ::pthread_key_create(key, cleanupfunc);
-    return key;
+    return name;
 }
-#endif
+
+
+} } // namespace log4cplus { namespace thread {
+} // end namespace dcmtk
 
 
 #ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
-void
-blockAllSignals()
-{
-#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
-    // Block all signals.
-    ::sigset_t signal_set;
-#if defined (_DARWIN_C_SOURCE) || defined (__OpenBSD__)
-    sigfillset (&signal_set);
-#else
-    ::sigfillset (&signal_set);
-#endif // _DARWIN_C_SOURCE || __OpenBSD__
-    ::pthread_sigmask (SIG_BLOCK, &signal_set, 0);
-#endif
-}
-#endif // DCMTK_LOG4CPLUS_SINGLE_THREADED
 
+namespace
+{
 
-tstring
-getCurrentThreadName()
+#  ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
+extern "C" void* threadStartFunc(void * param)
+#  elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+static unsigned WINAPI threadStartFunc(void * param)
+#  endif
 {
-    tostringstream tmp;
-    tmp << DCMTK_LOG4CPLUS_GET_CURRENT_THREAD;
-    OFSTRINGSTREAM_GETOFSTRING(tmp, str)
-    return str;
+    return dcmtk::log4cplus::thread::impl::ThreadStart::threadStartFuncWorker (param);
 }
 
+} // namespace
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread { namespace impl {
+
 
 #if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
-void*
+void* 
 ThreadStart::threadStartFuncWorker(void * arg)
 #elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
 unsigned
@@ -161,111 +206,115 @@ ThreadStart::threadStartFuncWorker(void * arg)
 #endif
 {
     blockAllSignals ();
-    helpers::SharedObjectPtr<helpers::LogLog> loglog
-        = helpers::LogLog::getLogLog();
+    helpers::LogLog * loglog = helpers::LogLog::getLogLog();
     if (! arg)
         loglog->error(DCMTK_LOG4CPLUS_TEXT("threadStartFunc()- arg is NULL"));
     else
     {
-        AbstractThread * ptr = OFstatic_cast(AbstractThread*, arg);
-        AbstractThreadPtr thread(ptr);
+        Thread * ptr = OFstatic_cast(Thread *, arg);
+        ThreadPtr thread(ptr);
 
-        // Decrease reference count increased by AbstractThread::start().
+        // Decrease reference count increased by Thread::start().
         ptr->removeReference ();
 
         try
         {
             thread->run();
         }
+        catch(STD_NAMESPACE exception const & e)
+        {
+            tstring err = DCMTK_LOG4CPLUS_TEXT("threadStartFunc()- run() terminated with an exception: ");
+            err += DCMTK_LOG4CPLUS_C_STR_TO_TSTRING(e.what());
+            loglog->warn(err);
+        }
         catch(...)
         {
             loglog->warn(DCMTK_LOG4CPLUS_TEXT("threadStartFunc()- run() terminated with an exception."));
         }
-        thread->running = false;
-        getNDC().remove();
+
+        thread::MutexGuard guard (thread->access_mutex);
+        thread->flags &= ~Thread::fRUNNING;
     }
 
+    threadCleanup ();
+
     return 0;
 }
 
 
-
-///////////////////////////////////////////////////////////////////////////////
-// AbstractThread ctor and dtor
-///////////////////////////////////////////////////////////////////////////////
-
-AbstractThread::AbstractThread()
-    : running(false)
+Thread::Thread()
+    : flags (0)
 #if defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
     , handle (INVALID_HANDLE_VALUE)
+    , thread_id (0)
+#else
+    , handle ()
 #endif
 {
 }
 
 
-
-AbstractThread::~AbstractThread()
+Thread::~Thread()
 {
-#if defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+#if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
+    if ((flags & fJOINED) == 0)
+        pthread_detach (handle);
+
+#elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
     if (handle != INVALID_HANDLE_VALUE)
         ::CloseHandle (handle);
+
 #endif
 }
 
 
-
-///////////////////////////////////////////////////////////////////////////////
-// AbstractThread public methods
-///////////////////////////////////////////////////////////////////////////////
-
 void
-AbstractThread::start()
+Thread::start()
 {
-    running = true;
+    flags |= fRUNNING;
 
     // Increase reference count here. It will be lowered by the running
     // thread itself.
     addReference ();
 
 #if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
-    if (::pthread_create(&handle, NULL, threadStartFunc, this) )
+    if (pthread_create(&handle, NULL, threadStartFunc, this) )
     {
         removeReference ();
-        helpers::SharedObjectPtr<helpers::LogLog> loglog
-            = helpers::LogLog::getLogLog();
-        loglog->error( DCMTK_LOG4CPLUS_TEXT("Thread creation was not successful") );
-        //throw STD_NAMESPACE runtime_error("Thread creation was not successful");
-        abort();
+        flags &= ~fRUNNING;
+        log4cplus::helpers::LogLog::getLogLog ()->error (
+            DCMTK_LOG4CPLUS_TEXT ("Thread creation was not successful"), true);
     }
 #elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
-    if (handle != INVALID_HANDLE_VALUE)
-    {
-        ::CloseHandle (handle);
-        handle = INVALID_HANDLE_VALUE;
-    }
-    HANDLE h;
-#if defined (_WIN32_WCE)
-    h = ::CreateThread  (0, 0, threadStartFunc, this, 0, &thread_id);
-#else
+    HANDLE h = handle;
+    handle = INVALID_HANDLE_VALUE;
+    if (h != INVALID_HANDLE_VALUE)
+        ::CloseHandle (h);
+
     h = OFreinterpret_cast(HANDLE,
         ::_beginthreadex (0, 0, threadStartFunc, this, 0, &thread_id));
-#endif
+    handle = h;
     if (! h)
     {
         removeReference ();
-        helpers::SharedObjectPtr<helpers::LogLog> loglog
-            = helpers::LogLog::getLogLog();
-        loglog->error( DCMTK_LOG4CPLUS_TEXT("Thread creation was not successful") );
-        //throw STD_NAMESPACE runtime_error("Thread creation was not successful");
-        abort();
+        flags &= ~fRUNNING;
+        log4cplus::helpers::LogLog::getLogLog ()->error (
+            DCMTK_LOG4CPLUS_TEXT ("Thread creation was not successful"), true);
     }
-    handle = h;
 #endif
 }
 
 
-DCMTK_LOG4CPLUS_THREAD_KEY_TYPE
-AbstractThread::getThreadId () const
+bool
+Thread::isRunning() const
+{
+    thread::MutexGuard guard (access_mutex);
+    return (flags & fRUNNING) != 0;
+}
+
+
+os_id_type
+Thread::getThreadId () const
 {
 #if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
     return handle;
@@ -275,24 +324,119 @@ AbstractThread::getThreadId () const
 }
 
 
-DCMTK_LOG4CPLUS_THREAD_HANDLE_TYPE
-AbstractThread::getThreadHandle () const
+os_handle_type
+Thread::getThreadHandle () const
 {
     return handle;
 }
 
 
 void
-AbstractThread::join () const
+Thread::join ()
 {
 #if defined(DCMTK_LOG4CPLUS_USE_PTHREADS)
-    ::pthread_join (handle, 0);
+    pthread_join (handle, 0);
 #elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
     ::WaitForSingleObject (handle, INFINITE);
 #endif
+    flags |= fJOINED;
+}
+
+
+} // namespace impl {
+
+
+//
+//
+//
+
+ThreadImplBase::~ThreadImplBase ()
+{ }
+
+
+//
+//
+//
+
+
+namespace
+{
+
+
+class ThreadImpl
+    : public impl::Thread
+{
+public:
+    ThreadImpl ()
+        : abs_thread (0)
+    { }
+
+    virtual ~ThreadImpl ()
+    { }
+
+    virtual
+    void
+    run ()
+    {
+        abs_thread->run ();
+    }
+
+    void
+    set_abs_thread (AbstractThread * at)
+    {
+        abs_thread = at;
+    }
+
+protected:
+    AbstractThread * abs_thread;
+
+private:
+    ThreadImpl(const ThreadImpl&);
+    ThreadImpl& operator=(const ThreadImpl&);
+};
+
+
+} // namespace
+
+
+//
+//
+//
+
+AbstractThread::AbstractThread ()
+    : thread (new ThreadImpl)
+{
+    OFstatic_cast(ThreadImpl *, thread.get ())->set_abs_thread (this);
+}
+
+
+bool
+AbstractThread::isRunning() const
+{
+    return OFstatic_cast(ThreadImpl *, thread.get ())->isRunning ();
+}
+
+
+void
+AbstractThread::start()
+{
+    OFstatic_cast(ThreadImpl *, thread.get ())->start ();
 }
 
 
-} } } // namespace dcmtk { namespace log4cplus { namespace thread {
+void
+AbstractThread::join () const
+{
+    OFstatic_cast(ThreadImpl *, thread.get ())->join ();
+}
+
+
+AbstractThread::~AbstractThread()
+{ }
+
+
+} } // namespace log4cplus { namespace thread { 
+} // end namespace dcmtk
+
 
 #endif // DCMTK_LOG4CPLUS_SINGLE_THREADED
diff --git a/oflog/libsrc/timehelp.cc b/oflog/libsrc/timehelp.cc
index 364f6b6..0b52a9d 100644
--- a/oflog/libsrc/timehelp.cc
+++ b/oflog/libsrc/timehelp.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -19,26 +19,32 @@
 // limitations under the License.
 
 #include "dcmtk/oflog/helpers/timehelp.h"
+#include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/streams.h"
 #include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/internal/internal.h"
+
+#include <algorithm>
+#include "dcmtk/ofstd/ofvector.h"
+#include <iomanip>
+#include <cassert>
+#include <cerrno>
+#if defined (UNICODE)
+#include <cwchar>
+#endif
 
-//#include <vector>
-//#include <iomanip>
-#include "dcmtk/ofstd/ofstream.h"
-//#include <cassert>
-#define INCLUDE_CASSERT
-#define INCLUDE_CTIME
-#define INCLUDE_CSTDLIB
-#include "dcmtk/ofstd/ofstdinc.h"
-
-#if defined(DCMTK_LOG4CPLUS_HAVE_FTIME)
-#include <sys/timeb.h>
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H)
+#include <sys/types.h>
 #endif
 
-#if defined(DCMTK_LOG4CPLUS_HAVE_GETTIMEOFDAY)
+#if defined(DCMTK_LOG4CPLUS_HAVE_SYS_TIME_H)
 #include <sys/time.h>
 #endif
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYS_TIMEB_H)
+#include <sys/timeb.h>
+#endif
+
 #if defined(DCMTK_LOG4CPLUS_HAVE_GMTIME_R) && !defined(DCMTK_LOG4CPLUS_SINGLE_THREADED)
 #define DCMTK_LOG4CPLUS_NEED_GMTIME_R
 #endif
@@ -47,34 +53,48 @@
 #define DCMTK_LOG4CPLUS_NEED_LOCALTIME_R
 #endif
 
+#define MAX(a, b) ((a) < (b) ? (b) : (a))
+
 
-namespace dcmtk { namespace log4cplus { namespace helpers {
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
 const int ONE_SEC_IN_USEC = 1000000;
 
+#if 0
+using STD_NAMESPACE mktime;
+using STD_NAMESPACE gmtime;
+using STD_NAMESPACE localtime;
+#if defined (UNICODE)
+using STD_NAMESPACE wcsftime;
+#else
+using STD_NAMESPACE strftime;
+#endif
+#endif
+
 
 //////////////////////////////////////////////////////////////////////////////
 // Time ctors
 //////////////////////////////////////////////////////////////////////////////
 
 Time::Time()
-: tv_sec(0),
-  tv_usec(0)
+    : tv_sec(0)
+    , tv_usec(0)
 {
 }
 
 
 Time::Time(time_t tv_sec_, long tv_usec_)
-: tv_sec(tv_sec_),
-  tv_usec(tv_usec_)
+    : tv_sec(tv_sec_)
+    , tv_usec(tv_usec_)
 {
     assert (tv_usec < ONE_SEC_IN_USEC);
 }
 
 
 Time::Time(time_t time)
-: tv_sec(time),
-  tv_usec(0)
+    : tv_sec(time)
+    , tv_usec(0)
 {
 }
 
@@ -82,16 +102,45 @@ Time::Time(time_t time)
 Time
 Time::gettimeofday()
 {
-#if defined(DCMTK_LOG4CPLUS_HAVE_GETTIMEOFDAY)
-    timeval tp;
+#if defined (DCMTK_LOG4CPLUS_HAVE_CLOCK_GETTIME)
+    struct timespec ts;
+    int res = clock_gettime (CLOCK_REALTIME, &ts);
+    assert (res == 0);
+    if (res != 0)
+        LogLog::getLogLog ()->error (
+            DCMTK_LOG4CPLUS_TEXT("clock_gettime() has failed"), true);
+
+    return Time (ts.tv_sec, ts.tv_nsec / 1000);
+
+#elif defined(DCMTK_LOG4CPLUS_HAVE_GETTIMEOFDAY)
+    struct timeval tp;
     ::gettimeofday(&tp, 0);
 
     return Time(tp.tv_sec, tp.tv_usec);
+
+#elif defined (_WIN32)
+    FILETIME ft;
+    GetSystemTimeAsFileTime (&ft);
+
+    typedef unsigned __int64 uint64_type;
+    uint64_type st100ns
+        = uint64_type (ft.dwHighDateTime) << 32
+        | ft.dwLowDateTime;
+
+    // Number of 100-ns intervals between UNIX epoch and Windows system time
+    // is 116444736000000000.
+    uint64_type const offset = uint64_type (116444736) * 1000 * 1000 * 1000;
+    uint64_type fixed_time = st100ns - offset;
+
+    return Time (fixed_time / (10 * 1000 * 1000),
+        fixed_time % (10 * 1000 * 1000) / 10);
+
 #elif defined(DCMTK_LOG4CPLUS_HAVE_FTIME)
     struct timeb tp;
-    ::ftime(&tp);
+    ftime(&tp);
 
     return Time(tp.time, tp.millitm * 1000);
+
 #else
 #warning "Time::gettimeofday()- low resolution timer: gettimeofday and ftime unavailable"
     return Time(::time(0), 0);
@@ -104,12 +153,11 @@ Time::gettimeofday()
 //////////////////////////////////////////////////////////////////////////////
 
 time_t
-Time::setTime(struct tm* t)
+Time::setTime(tm* t)
 {
-    time_t time = ::mktime(t);
-    if(time != -1) {
+    time_t time = mktime(t);
+    if (time != -1)
         tv_sec = time;
-    }
 
     return time;
 }
@@ -123,115 +171,116 @@ Time::getTime() const
 
 
 void
-Time::gmtime(struct tm* t) const
+Time::gmtime(tm* t) const
 {
     time_t clock = tv_sec;
-#ifdef DCMTK_LOG4CPLUS_NEED_GMTIME_R
-    ::gmtime_r(&clock, t);
+#if defined (DCMTK_LOG4CPLUS_HAVE_GMTIME_S) && defined (_MSC_VER) && _MSC_VER > 1200
+    gmtime_s (t, &clock);
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GMTIME_S) && defined (__BORLANDC__)
+    gmtime_s (&clock, t);
+#elif defined (DCMTK_LOG4CPLUS_NEED_GMTIME_R)
+    gmtime_r (&clock, t);
 #else
-    struct tm* tmp = ::gmtime(&clock);
+    tm* tmp = ::gmtime(&clock);
     *t = *tmp;
 #endif
 }
 
 
 void
-Time::localtime(struct tm* t) const
+Time::localtime(tm* t) const
 {
     time_t clock = tv_sec;
 #ifdef DCMTK_LOG4CPLUS_NEED_LOCALTIME_R
     ::localtime_r(&clock, t);
 #else
-    struct tm* tmp = ::localtime(&clock);
+    tm* tmp = ::localtime(&clock);
     *t = *tmp;
 #endif
 }
 
 
-namespace
+namespace 
 {
 
-static tstring const padding_zeros[4] =
+
+static log4cplus::tstring const padding_zeros[4] =
 {
-    tstring (DCMTK_LOG4CPLUS_TEXT("000")),
-    tstring (DCMTK_LOG4CPLUS_TEXT("00")),
-    tstring (DCMTK_LOG4CPLUS_TEXT("0")),
-    tstring (DCMTK_LOG4CPLUS_TEXT(""))
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT("000")),
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT("00")),
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT("0")),
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT(""))
 };
 
-static tstring const uc_q_padding_zeros[4] =
+
+static log4cplus::tstring const uc_q_padding_zeros[4] =
 {
-    tstring (DCMTK_LOG4CPLUS_TEXT(".000")),
-    tstring (DCMTK_LOG4CPLUS_TEXT(".00")),
-    tstring (DCMTK_LOG4CPLUS_TEXT(".0")),
-    tstring (DCMTK_LOG4CPLUS_TEXT("."))
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT(".000")),
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT(".00")),
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT(".0")),
+    log4cplus::tstring (DCMTK_LOG4CPLUS_TEXT("."))
 };
 
-}
-
 
+static
 void
-Time::build_q_value (tstring & q_str) const
+build_q_value (log4cplus::tstring & q_str, long tv_usec)
 {
-    q_str = convertIntegerToString(tv_usec / 1000);
+    convertIntegerToString(q_str, tv_usec / 1000);
     size_t const len = q_str.length();
     if (len <= 2)
         q_str.insert (0, padding_zeros[q_str.length()]);
 }
 
 
-void
-Time::build_uc_q_value (tstring & uc_q_str) const
+static
+void 
+build_uc_q_value (log4cplus::tstring & uc_q_str, long tv_usec,
+    log4cplus::tstring & tmp)
 {
-    build_q_value (uc_q_str);
-
-#if defined(DCMTK_LOG4CPLUS_HAVE_GETTIMEOFDAY)
-    tstring usecs (convertIntegerToString(tv_usec % 1000));
-    size_t usecs_len = usecs.length();
-    usecs.insert (0, usecs_len <= 3
-                  ? uc_q_padding_zeros[usecs_len] : uc_q_padding_zeros[3]);
-    uc_q_str.append (usecs);
-#else
-    uc_q_str.append (uc_q_padding_zeros[0]);
-#endif
+    build_q_value (uc_q_str, tv_usec);
 
+    convertIntegerToString(tmp, tv_usec % 1000);
+    size_t const usecs_len = tmp.length();
+    tmp.insert (0, usecs_len <= 3
+        ? uc_q_padding_zeros[usecs_len] : uc_q_padding_zeros[3]);
+    uc_q_str.append (tmp);
 }
 
 
-tstring
-Time::getFormattedTime(const tstring& fmt_orig, bool use_gmtime) const
+} // namespace
+
+
+log4cplus::tstring
+Time::getFormattedTime(const log4cplus::tstring& fmt_orig, bool use_gmtime) const
 {
     if (fmt_orig.empty () || fmt_orig[0] == 0)
-        return tstring ();
-
-    struct tm time;
+        return log4cplus::tstring ();
 
-    if(use_gmtime)
+    tm time;
+    
+    if (use_gmtime)
         gmtime(&time);
-    else
+    else 
         localtime(&time);
-
+    
     enum State
     {
         TEXT,
         PERCENT_SIGN
     };
+    
+    internal::gft_scratch_pad & gft_sp = internal::get_gft_scratch_pad ();
+    gft_sp.reset ();
 
-    tstring fmt (fmt_orig);
-    tstring ret;
-    ret.reserve (OFstatic_cast(size_t, fmt.size () * 1.35));
+    gft_sp.fmt.assign (fmt_orig);
+    gft_sp.ret.reserve (OFstatic_cast(size_t, gft_sp.fmt.size () * 1.35));
     State state = TEXT;
 
-    tstring q_str;
-    bool q_str_valid = false;
-
-    tstring uc_q_str;
-    bool uc_q_str_valid = false;
-
     // Walk the format string and process all occurences of %q and %Q.
-
-    for (tstring::const_iterator fmt_it = fmt.begin ();
-         fmt_it != fmt.end (); ++fmt_it)
+    
+    for (log4cplus::tstring::const_iterator fmt_it = gft_sp.fmt.begin ();
+         fmt_it != gft_sp.fmt.end (); ++fmt_it)
     {
         switch (state)
         {
@@ -240,42 +289,56 @@ Time::getFormattedTime(const tstring& fmt_orig, bool use_gmtime) const
             if (*fmt_it == DCMTK_LOG4CPLUS_TEXT ('%'))
                 state = PERCENT_SIGN;
             else
-                ret.append (1, *fmt_it);
+                gft_sp.ret.append(1, *fmt_it);
         }
         break;
-
+            
         case PERCENT_SIGN:
         {
             switch (*fmt_it)
             {
             case DCMTK_LOG4CPLUS_TEXT ('q'):
             {
-                if (! q_str_valid)
+                if (! gft_sp.q_str_valid)
                 {
-                    build_q_value (q_str);
-                    q_str_valid = true;
+                    build_q_value (gft_sp.q_str, tv_usec);
+                    gft_sp.q_str_valid = true;
                 }
-                ret.append (q_str);
+                gft_sp.ret.append (gft_sp.q_str);
                 state = TEXT;
             }
             break;
-
+            
             case DCMTK_LOG4CPLUS_TEXT ('Q'):
             {
-                if (! uc_q_str_valid)
+                if (! gft_sp.uc_q_str_valid)
+                {
+                    build_uc_q_value (gft_sp.uc_q_str, tv_usec, gft_sp.tmp);
+                    gft_sp.uc_q_str_valid = true;
+                }
+                gft_sp.ret.append (gft_sp.uc_q_str);
+                state = TEXT;
+            }
+            break;
+
+            // Windows do not support %s format specifier
+            // (seconds since epoch).
+            case DCMTK_LOG4CPLUS_TEXT ('s'):
+            {
+                if (! gft_sp.s_str_valid)
                 {
-                    build_uc_q_value (uc_q_str);
-                    uc_q_str_valid = true;
+                    convertIntegerToString (gft_sp.s_str, tv_sec);
+                    gft_sp.s_str_valid = true;
                 }
-                ret.append (uc_q_str);
+                gft_sp.ret.append (gft_sp.s_str);
                 state = TEXT;
             }
             break;
 
             default:
             {
-                ret.append (1, DCMTK_LOG4CPLUS_TEXT ('%'));
-                ret.append (1, *fmt_it);
+                gft_sp.ret.append (1, DCMTK_LOG4CPLUS_TEXT ('%'));
+                gft_sp.ret.append (1, *fmt_it);
                 state = TEXT;
             }
             }
@@ -286,24 +349,43 @@ Time::getFormattedTime(const tstring& fmt_orig, bool use_gmtime) const
 
     // Finally call strftime/wcsftime to format the rest of the string.
 
-    ret.swap (fmt);
-    size_t buffer_size = fmt.size () + 1;
-    char *buffer = OFstatic_cast(char *, malloc(buffer_size));
+    gft_sp.ret.swap (gft_sp.fmt);
+    size_t buffer_size = gft_sp.fmt.size () + 1;
     size_t len;
+
+    // Limit how far can the buffer grow. This is necessary so that we
+    // catch bad format string. Some implementations of strftime() signal
+    // both too small buffer and invalid format string by returning 0
+    // without changing errno. 
+    size_t const buffer_size_max
+        = MAX(OFstatic_cast(size_t, 1024), buffer_size * 16);
+
     do
     {
-        len = ::strftime(buffer, buffer_size, fmt.c_str(), &time);
+        gft_sp.buffer.resize (buffer_size);
+        errno = 0;
+#ifdef UNICODE
+        len = wcsftime(&gft_sp.buffer[0], buffer_size,
+            gft_sp.fmt.c_str(), &time);
+#else
+        len = strftime(&gft_sp.buffer[0], buffer_size,
+            gft_sp.fmt.c_str(), &time);
+#endif
         if (len == 0)
         {
+            int const eno = errno;
             buffer_size *= 2;
-            buffer = OFstatic_cast(char *, realloc(buffer, buffer_size));
+            if (buffer_size > buffer_size_max)
+            {
+                LogLog::getLogLog ()->error (
+                    DCMTK_LOG4CPLUS_TEXT("Error in strftime(): ")
+                    + convertIntegerToString (eno), true);
+            }
         }
-    }
+    } 
     while (len == 0);
-    ret.assign (&buffer[0], len);
-    free(buffer);
 
-    return ret;
+    return tstring (&*gft_sp.buffer.begin (), len);
 }
 
 
@@ -342,7 +424,7 @@ Time::operator/=(long rhs)
 {
     long rem_secs = OFstatic_cast(long, tv_sec % rhs);
     tv_sec /= rhs;
-
+    
     tv_usec /= rhs;
     tv_usec += OFstatic_cast(long, (rem_secs * ONE_SEC_IN_USEC) / rhs);
 
@@ -401,7 +483,7 @@ bool
 operator<(const Time& lhs, const Time& rhs)
 {
     return (   (lhs.sec() < rhs.sec())
-            || (   (lhs.sec() == rhs.sec())
+            || (   (lhs.sec() == rhs.sec()) 
                 && (lhs.usec() < rhs.usec())) );
 }
 
@@ -417,7 +499,7 @@ bool
 operator>(const Time& lhs, const Time& rhs)
 {
     return (   (lhs.sec() > rhs.sec())
-            || (   (lhs.sec() == rhs.sec())
+            || (   (lhs.sec() == rhs.sec()) 
                 && (lhs.usec() > rhs.usec())) );
 }
 
@@ -444,4 +526,5 @@ operator!=(const Time& lhs, const Time& rhs)
 }
 
 
-} } } // namespace dcmtk { namespace log4cplus { namespace helpers {
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/tls.cc b/oflog/libsrc/tls.cc
new file mode 100644
index 0000000..4c128f3
--- /dev/null
+++ b/oflog/libsrc/tls.cc
@@ -0,0 +1,42 @@
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/thread/impl/tls.h"
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread { namespace impl {
+
+
+#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+
+//! This is intentionally allocated using freestore and leaked. The
+//! amount is small (so far only 1 length vector). This is to avoid
+//! initialization order fiasco.
+OFVector<tls_value_type> * tls_single_threaded_values;
+
+#endif
+
+
+} } } // namespace log4cplus { namespace thread { namespace impl {
+} // end namespace dcmtk
